<?php
namespace Teknisa\EST\Modules\EstoqueCego\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Est92000ConsultaInventarioCegoService {
    
    protected $Est92000ConsultaInventarioCegoFactory;
    protected $dataSourceManager;
    
    public function __construct($Est92000factory, $environment,$dataSourceManager) {
        $this->Est92000ConsultaInventarioCegoFactory = $Est92000factory;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
    }
    
    public function formatMutipleFilialCode (&$conditions){
        
        foreach($conditions as &$condition){
            if($condition['columnName'] = 'CDFILIAL'){
                $newCondition = join("_",$condition['value']);
                $condition['value'] = "_" . $newCondition . "_";;
                break;
            }
        }
    }
    
    public function formatDSDATAField ($row){
        
        switch($row['IDSITESTCEGO']){
            case "AP":
                $IDSITESTCEGO = "Aprovado";
                break;
            case "DG":
                $IDSITESTCEGO = "Digitado";
                break;
            case "ED":
                $IDSITESTCEGO = "Em Digitação";
                break;
            case "PR":
                $IDSITESTCEGO = "Programado";
                break;
            case "PN":
                $IDSITESTCEGO = "Programado/Não Realizado";
                break;
            case "EN":
                $IDSITESTCEGO = "Em Digitação/Não Realizado";
                break;
            case "DN":
                $IDSITESTCEGO = "Digitado/Não Realizado";
                break;
            default:
                break;
        }
        
        return  substr($row['DTCONTAGEM'],0,10) .  " - Data Geração: " . substr($row['DTGERACAOINVEST'],0,10) . 
        " - Situação: " . $IDSITESTCEGO;
    }
    
    public function getFilialInfo($filial){
        $params = ["CDFILIAL" => $filial];
        return $this->Est92000ConsultaInventarioCegoFactory->getFilialInfo($params);
    }
    
}
