<?php

/**
 * GepSolicitacao
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @property   GepAtividade GepAtividade
 * @package    DbModel
 * @subpackage Model
 * @author     walterluiz - 21/02/2011 09:38:47 <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepSolicitacao extends DaoGepSolicitacao
{


    /**
     * Consulta dados de uma determinada solicitacao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $solicitacao Numero da solicitacao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaSolicitacao($nrorg, $solicitacao){
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRSOLICITACAO = ?',
                array(
                 $nrorg,
                 $solicitacao,
                )
            );

            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Consulta dados de uma determinada solicita??o.
     *
     * @param integer $nrorg         N?mero da Organiza??o.
     * @param integer $nrsolicitacao N?mero da solicita??o.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaExistenciaSolicitacao($nrorg, $nrsolicitacao){
        $db = TkDbAdapter::getWorkConnection(TK_DSN);

        $sql = $db->createQuery()
            ->select('SO.NRSOLICITACAO')
            ->from('GEPSOLICITACAO SO')
            ->where('SO.NRSOLICITACAO = ? ', array($nrsolicitacao))
            ->addWhere('SO.NRORG = ? ', array($nrorg));

        $resulte = $sql->execute()->toArray();
        return $resulte;
    }


    /**
     * Consulta dados de uma determinada solicita??o.
     *
     * @param integer $nrorg         N?mero da Organiza??o.
     * @param integer $nrsolicitacao N?mero da solicita??o.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaNomeSolicitacao($nrorg, $nrsolicitacao){
        $db = TkDbAdapter::getWorkConnection(TK_DSN);

        $sql = $db->createQuery()
            ->select('SO.DSREFERENCIASOLI')
            ->from('GEPSOLICITACAO SO')
            ->where('SO.NRSOLICITACAO = ? ', array($nrsolicitacao))
            ->addWhere('SO.NRORG = ? ', array($nrorg));

        $resulte = $sql->execute()->toArray();
        return $resulte;
    }


    /**
     * Retorna o ultimo codigo de depencia j? cadastrado.
     *
     * @param integer $nrorg N?mero da Organiza??o.
     *
     * @return multitype:|boolean
     */
    public function ultimoCodigoDependencia($nrorg){
        try {
            $sql = "SELECT MAX(NRGRUPODEPENDENCIA) AS MAIOR
                      FROM GEP_SOLICITACAO
                     WHERE NRORG = $nrorg";

            $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
            return $resultado[0]['MAIOR'];
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Monta o SQL para a tabQuery de Depend?ncia entre as Solicita??es.
     *
     * @param integer $nrorg N?mero da Organiza??o.
     * @param integer $grupo N?mero do grupo de depend?ncia.
     *
     * @return string
     */
    public static function retornaSqlDependentes($nrorg, $grupo){
        $sql = "SELECT SO.NRSOLICITACAO,
                       SO.DSREFERENCIASOLI AS NRSOLICITACAO__LABEL,
                       SO.NRSITUACAO,
                       CASE
                         WHEN SI.NMSITUACAO IS NULL
                         THEN 'Em elaboração'
                         ELSE SI.NMSITUACAO
                       END AS NMSITUACAO,
                       SO.NRPARCOPERRESP,
                       PA.NMPRINCIPALPARC,
                       PE.NMPERFILACESSO,
                       SO.CDOPERINCLUSAO,
                       OP.NMOPERADOR,
                       SO.NRORG,
                       SO.NRGRUPODEPENDENCIA
                  FROM GEP_SOLICITACAO SO
                LEFT JOIN GEP_SITUACAO SI
                              ON SI.NRORG       = SO.NRORG
                              AND SI.NRSITUACAO = SO.NRSITUACAO
                LEFT JOIN PERFILACESSO PE
                              ON PE.NRORG           = SO.NRORG
                              AND PE.NRPERFILACESSO = SO.NRPERFILACESSORESP
                LEFT JOIN OPERADOR OP
                              ON OP.NRORG       = SO.NRORG
                              AND OP.CDOPERADOR = SO.CDOPERINCLUSAO
                LEFT JOIN PARCNEGOCIO PA
                              ON PA.NRORG          = SO.NRORG
                              AND PA.NRPARCNEGOCIO = SO.NRPARCOPERRESP
                WHERE SO.NRORG = ".$nrorg."
                  AND SO.NRGRUPODEPENDENCIA = ".$grupo."
                ORDER BY SO.NRSOLICITACAO DESC";

        return $sql;
    }


    /**
     * Retorna dados de uma solicita??o por grupo.
     *
     * @param integer $nrorg  N?mero da Organiza??o.
     * @param integer $filial C?digo da Filial.
     * @param integer $grupo  N?mero do Grupo.
     *
     * @return multitype:|boolean
     */
    public static function retornaSolicitacaoPorGrupo($nrorg, $filial, $grupo){
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND NRGRUPODEPENDENCIA = ?',
                array(
                     $nrorg,
                     $filial,
                     $grupo,
                )
            );

            return $obj;
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /*/**
    * Consulta os produtos de alguma solicitacao para determinado tipo de fluxo.
    *
    * @param integer $nrorg       Numero da organizacao.
    * @param integer $nrtipofluxo Numero do tipo de fluxo.
    *
    * @return string $sql         Resultado da query.
    */
    /*public static function consultaProdutoSoliPorTipoFluxo(
        $nrorg,
        $nrtipofluxo
        ){
            $db = TkDb::singleton();
            $sql = 'SELECT GS.NRSOLICITACAO, GS.DSREFERENCIASOLI, COUNT(GP.NRPRODUTOSOLI) AS QUANT
                    FROM GEP_SOLICITACAO GS, GEP_PRODUTOSOLI GP,
                    GEP_TIPOFLUXO GT
                    WHERE GP.NRSOLICITACAO = GS.NRSOLICITACAO
                    AND   GP.NRORG = GS.NRORG
                    AND   GS.NRTIPOFLUXO = GT.NRTIPOFLUXO
                    AND   GS.NRORG = GT.NRORG
                    AND   GT.NRTIPOFLUXO = '.$nrtipofluxo.'
                    AND   GT.NRORG = '.$nrorg.'
                    GROUP BY GS.NRSOLICITACAO, GS.DSREFERENCIASOLI
                    ORDER BY GS.NRSOLICITACAO';

            $resultado = $db->fetchAll($sql);

            $objects = self::createObjectsFromArray($resultado);
            TkDebug::var_dump($objects);

            return $objects;
        }
        */


    /**
     * Retorna query para a tab de solicita??o.
     *
     * @param integer $nrorg       Numero da organizacao.
     * @param integer $filial      Codigo da filial.
     * @param integer $parceiro    Codigo do parceiro.
     * @param string  $entregasoli Se a tela e de entrega de produto ou nao.
     *
     * @return string
     */
    public static function retornaSqlTabSolicitacao($nrorg, $filial, $parceiro, $entregasoli, $tiposfluxo){
        if ($entregasoli === 'true') {
            $add_where = "AND GEP_SOLICITACAO.NRTIPOFLUXO = 2";
        } else {
            $add_where = "AND GEP_SOLICITACAO.NRTIPOFLUXO IN ($tiposfluxo)";
        }

        $sql = "SELECT * FROM
                      (SELECT GEP_SOLICITACAO.NRSOLICITACAO,
                       GEP_SOLICITACAO.NRTIPOFLUXO,
                       GEP_SOLICITACAO.CDFILIAL,
                       GEP_SOLICITACAO.NRTIPOSOLICITACAO,
                       TS.NMTIPOSOLICITACAO AS NRTIPOSOLICITACAO__LABEL,
                       GEP_SOLICITACAO.NRSITUACAO,
                       CASE
                         WHEN SI.NMSITUACAO IS NULL
                         THEN 'Em elaboração'
                         ELSE SI.NMSITUACAO
                       END AS NRSITUACAO__LABEL,
                       GEP_SOLICITACAO.NRPARCNEGOACIONADO,
                       PARCNEGOACIONADO.NMPRINCIPALPARC AS NRPARCNEGOACIONADO__LABEL,
                       GEP_SOLICITACAO.NRPARCOPERACIONADO,
                       PARCOPERACIONADO.NMPRINCIPALPARC AS NRPARCOPERACIONADO__LABEL,
                       GEP_SOLICITACAO.NRPARCNEGOSOLI,
                       PARCNEGOSOLI.NMPRINCIPALPARC AS NRPARCNEGOSOLI__LABEL,
                       GEP_SOLICITACAO.NRPARCOPERSOLI,
                       PARCOPERSOLI.NMPRINCIPALPARC AS NRPARCOPERSOLI__LABEL,
                       GEP_SOLICITACAO.NRPARCOPERRESP,
                       PARCOPERRESP.NMPRINCIPALPARC AS NRPARCOPERRESP__LABEL,
                       GEP_SOLICITACAO.NRPERFILACESSORESP,
                       PE.NMPERFILACESSO AS NRPERFILACESSORESP__LABEL,
                       GEP_SOLICITACAO.NRPARCOPERENCE,
                       PARCOPERENCE.NMPRINCIPALPARC AS NRPARCOPERENCE__LABEL,
                       GEP_SOLICITACAO.CDSETOR,
                       SE.NMSETOR AS CDSETOR__LABEL,
                       GEP_SOLICITACAO.NRGEPAMBIENTE,
                       AMB.DSGEPAMBIENTE AS NRGEPAMBIENTE__LABEL,
                       GEP_SOLICITACAO.DSREFERENCIASOLI,
                       OG.TXOBSERVACAO AS OBSERVACAO_GERAL,
                       OO.TXOBSERVACAO AS OBSERVACAO_OPERADOR,
                       OO.DSATRIBUTOFONTE,
                       GEP_SOLICITACAO.IDSOLIENCERRADA,
                       CASE
                         WHEN GEP_SOLICITACAO.IDSOLIENCERRADA = 'S'
                         THEN 'Encerrada'
                         ELSE 'N&atilde;o encerrada'
                       END AS NMSOLIENCERRADA,
                       GEP_SOLICITACAO.DTENCERRAMENTOSOLI,
                       GEP_SOLICITACAO.NRORG,
                       GEP_SOLICITACAO.IDATIVO,
                       GEP_SOLICITACAO.DTINCLUSAO,
                       GEP_SOLICITACAO.DTULTATU,
                       GEP_SOLICITACAO.NRORGINCLUSAO,
                       GEP_SOLICITACAO.CDOPERINCLUSAO,
                       OPERINCLUSAO.NMOPERADOR AS CDOPERINCLUSAO__LABEL,
                       GEP_SOLICITACAO.NRORGULTATU,
                       GEP_SOLICITACAO.CDOPERULTATU,
                       OPERULTATU.NMOPERADOR AS CDOPERULTATU__LABEL,
                       GEP_SOLICITACAO.NRGRUPODEPENDENCIA
                  FROM GEP_SOLICITACAO
             LEFT JOIN GEP_SITUACAO SI ON (GEP_SOLICITACAO.NRORG       = SI.NRORG AND
                                           GEP_SOLICITACAO.NRTIPOFLUXO = SI.NRTIPOFLUXO AND
                                           GEP_SOLICITACAO.NRSITUACAO  = SI.NRSITUACAO)
                  JOIN GEP_TIPOSOLICITACAO TS ON (TS.NRORG             = GEP_SOLICITACAO.NRORG AND
                                                  TS.NRTIPOFLUXO       = GEP_SOLICITACAO.NRTIPOFLUXO AND
                                                  TS.NRTIPOSOLICITACAO = GEP_SOLICITACAO.NRTIPOSOLICITACAO)
             LEFT JOIN SETOR SE ON (SE.NRORG   = GEP_SOLICITACAO.NRORG AND
                                    SE.CDSETOR = GEP_SOLICITACAO.CDSETOR)
             LEFT JOIN GEP_AMBIENTE AMB ON (AMB.NRORG         = GEP_SOLICITACAO.NRORG AND
                                            AMB.NRGEPAMBIENTE = GEP_SOLICITACAO.NRGEPAMBIENTE)
             LEFT JOIN PARCNEGOCIO PARCNEGOACIONADO ON (GEP_SOLICITACAO.NRORG              = PARCNEGOACIONADO.NRORG AND
                                                        GEP_SOLICITACAO.NRPARCNEGOACIONADO = PARCNEGOACIONADO.NRPARCNEGOCIO)
             LEFT JOIN PARCNEGOCIO PARCOPERACIONADO ON (GEP_SOLICITACAO.NRORG              = PARCOPERACIONADO.NRORG AND
                                                        GEP_SOLICITACAO.NRPARCOPERACIONADO = PARCOPERACIONADO.NRPARCNEGOCIO)
             LEFT JOIN PARCNEGOCIO PARCNEGOSOLI ON (GEP_SOLICITACAO.NRORG          = PARCNEGOSOLI.NRORG AND
                                                    GEP_SOLICITACAO.NRPARCNEGOSOLI = PARCNEGOSOLI.NRPARCNEGOCIO)
             LEFT JOIN PARCNEGOCIO PARCOPERSOLI ON (GEP_SOLICITACAO.NRORG          = PARCOPERSOLI.NRORG AND
                                                    GEP_SOLICITACAO.NRPARCOPERSOLI = PARCOPERSOLI.NRPARCNEGOCIO)
             LEFT JOIN PARCNEGOCIO PARCOPERRESP ON (GEP_SOLICITACAO.NRORG          = PARCOPERRESP.NRORG AND
                                                    GEP_SOLICITACAO.NRPARCOPERRESP = PARCOPERRESP.NRPARCNEGOCIO)
             LEFT JOIN PARCNEGOCIO PARCOPERENCE ON (GEP_SOLICITACAO.NRORG          = PARCOPERENCE.NRORG AND
                                                    GEP_SOLICITACAO.NRPARCOPERENCE = PARCOPERENCE.NRPARCNEGOCIO)
                     JOIN OPERADOR OPERINCLUSAO ON (GEP_SOLICITACAO.NRORG          = OPERINCLUSAO.NRORG AND
                                                    GEP_SOLICITACAO.CDOPERINCLUSAO = OPERINCLUSAO.CDOPERADOR)
                     JOIN OPERADOR OPERULTATU ON (GEP_SOLICITACAO.NRORG        = OPERULTATU.NRORG AND
                                                  GEP_SOLICITACAO.CDOPERULTATU = OPERULTATU.CDOPERADOR)
             LEFT JOIN GEP_OBSERVACAOSOLI OG ON (OG.NRSOLICITACAO = GEP_SOLICITACAO.NRSOLICITACAO AND
                                                 OG.NRORG         = GEP_SOLICITACAO.NRORG AND
                                                 OG.NRPARCNEGOCIO IS NULL)
             LEFT JOIN GEP_OBSERVACAOSOLI OO ON (OO.NRSOLICITACAO = GEP_SOLICITACAO.NRSOLICITACAO AND
                                                 OO.NRORG         = GEP_SOLICITACAO.NRORG AND
                                                 OO.NRPARCNEGOCIO = $parceiro)
             LEFT JOIN PERFILACESSO PE ON (PE.NRORG          = GEP_SOLICITACAO.NRORG AND
                                           PE.NRPERFILACESSO = GEP_SOLICITACAO.NRPERFILACESSORESP)
                 WHERE GEP_SOLICITACAO.NRORG       = $nrorg
                   AND GEP_SOLICITACAO.CDFILIAL    = $filial
                   $add_where
                   /*AND GEP_SOLICITACAO.NRSOLICITACAO IN (SELECT DISTINCT(SOL.NRSOLICITACAO)
                                                          FROM GEP_TIPOPARCFLUXO TPF, PARCNEGOCIO PA, GEP_OPERADORFLUXO OPF, GEP_SOLICITACAO SOL
                                                         WHERE SOL.NRORG = 1
                                                           AND (
                                                                (OPF.NRPARCOPERADOR = 2259 AND
                                                                 OPF.NRTIPOFLUXO = SOL.NRTIPOFLUXO AND
                                                                 OPF.NRORG = SOL.NRORG)
                                                                OR
                                                                (PA.NRPARCNEGOCIO = 2259 AND
                                                                 PA.NRORG = SOL.NRORG AND
                                                                 PA.CDTIPOPARCPRINCIPAL = TPF.CDTIPOPARCEIRO AND
                                                                 TPF.NRTIPOFLUXO = SOL.NRTIPOFLUXO AND
                                                                 TPF.NRORG = SOL.NRORG )
                                                               ))*/
              ORDER BY GEP_SOLICITACAO.NRSOLICITACAO DESC) GEP_SOLICITACAO
                 WHERE WHERE_PLACEHOLDER
                   AND FILTER_PLACEHOLDER
              ";

        return $sql;
    }


    /**
     * Consulta as solicita��es criadas por um operador informado.
     *
     * @param integer $nrorg    N�mero da Organiza��o.
     * @param integer $operador C�digo do Operador.
     *
     * @return multitype:|boolean
     */
    public static function retornaSoliPorOperInclusao($nrorg, $operador){
        try {
            $sql = "SELECT NRPARCNEGOACIONADO AS PARCEIRO
                      FROM GEP_SOLICITACAO
                     WHERE NRORG = $nrorg
                       AND CDOPERINCLUSAO = $operador";

            $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
            return $resultado[0]['PARCEIRO'];
        } catch (Exception $e) {
            tk_warning('Erro desconhecido (GepSolicitacao): '.$e->getMessage());
            return false;
        }
    }


    /**
     * Retorna a query para a tela de atividade por solicita��o.
     *
     * @param integer $nrorg       N�mero da Organiza��o.
     * @param integer $solicitacao N�mero da solicita��o.
     *
     * @return string
     */
    public static function retornaSqlAtividadeSoli($nrorg, $solicitacao){
        $sql = 'SELECT GA.NRSOLICITACAO,
                       GA.NRATIVIDADE,
                       GA.NRATIVIDADEPROC,
                       AP.NMATIVIDADEPROC,
                       GA.NRPARCOPERRESP,
                       PA.NMPRINCIPALPARC,
                       GA.IDSITUACAOATIV,
                       GA.DTINICIOPLANEJADO,
                       GA.DTFIMPLANEJADO,
                       GA.NRORG
                  FROM GEP_ATIVIDADE GA
                LEFT JOIN GEP_ATIVIDADEPROC AP
                       ON GA.NRORG = AP.NRORG
                      AND GA.NRATIVIDADEPROC = AP.NRATIVIDADEPROC
                LEFT JOIN PARCNEGOCIO PA
                       ON GA.NRORG = PA.NRORG
                      AND GA.NRPARCOPERRESP = PA.NRPARCNEGOCIO
                 WHERE GA.NRORG = '.$nrorg;
        if ($solicitacao !== null) {
            $sql .=' AND GA.NRSOLICITACAO = '.$solicitacao;
        } else {
            $sql .=' AND GA.NRSOLICITACAO = null';
        }

        return $sql;
    }


    /**
     * Maior codigo de solicitacao ja registrado.
     *
     * @param integer $nrorg Numero da organizacao.
     *
     * @return multitype:|boolean
     */
    public static function ultimoCodigoSolicitacao($nrorg){
        try {
            $db = TkDbAdapter::getWorkConnection();

            $sql = $db->createQuery()
                ->select('MAX(NRSOLICITACAO) AS MAIOR')
                ->from('GEPSOLICITACAO')
                ->where("NRORG = '".$nrorg."'");

            $resultado = $sql->execute()->getFirst()->_values['MAIOR'];
            return $resultado;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Retorna a query para o search ddas solicitacoes disponiveis para dependencia.
     *
     * @param integer $nrorg       Numero da organizacao.
     * @param integer $filial      Codigo da filial.
     * @param integer $tpfluxo     Tipo de fluxo.
     * @param integer $solicitacao Codigo da solicitacao.
     *
     * @return string
     */
    public static function retornaQuerySoliDependentes($nrorg, $filial, $tpfluxo, $solicitacao){
        $query = "SELECT SO.NRSOLICITACAO,
					    SO.DSREFERENCIASOLI,
					    SO.NRSITUACAO,
					    CASE
					      WHEN SI.NMSITUACAO IS NULL
					      THEN 'Em elaboração'
                         ELSE SI.NMSITUACAO
					    END AS NMSITUACAO,
					    SO.NRPARCOPERRESP,
					    PA.NMPRINCIPALPARC,
					    PE.NMPERFILACESSO,
					    SO.CDOPERINCLUSAO,
					    OP.NMOPERADOR,
					    SO.NRORG, SO.NRGRUPODEPENDENCIA
					  FROM
					    GEP_SOLICITACAO SO
					  LEFT JOIN GEP_SITUACAO SI
					  ON SO.NRORG        = SI.NRORG
					  AND SO.NRTIPOFLUXO = SI.NRTIPOFLUXO
					  AND SO.NRSITUACAO  = SI.NRSITUACAO
					  LEFT JOIN PERFILACESSO PE
					  ON PE.NRORG           = SO.NRORG
					  AND PE.NRPERFILACESSO = SO.NRPERFILACESSORESP
					  LEFT JOIN PARCNEGOCIO PA
					  ON PA.NRORG          = SO.NRORG
					  AND PA.NRPARCNEGOCIO  = SO.NRPARCOPERRESP
					  LEFT JOIN OPERADOR OP
					  ON OP.NRORG          = PA.NRORG
					  AND OP.CDOPERADOR     = SO.CDOPERINCLUSAO
					  WHERE SO.NRORG =  ".$nrorg."
					  AND SO.CDFILIAL  = ".$filial."
					  AND SO.NRTIPOFLUXO   = ".$tpfluxo."
					  AND SO.NRSOLICITACAO <> ".$solicitacao."
					  AND SO.NRGRUPODEPENDENCIA IS NULL";

        return $query;
    }


    /**      ok
     * Retorna o numero de dependentes de um grupo.
     *
     * @param integer $nrorg       Numero da organizacao.
     * @param integer $grupo       Numero do grupo.
     *
     * @return integer
     */
    static function retornaNumDependentes($nrorg, $grupo){
        try {
            $sql = "SELECT COUNT(*) AS TOTAL FROM (SELECT GEP_SOLICITACAO.NRSOLICITACAO,
                           GEP_SOLICITACAO.DSREFERENCIASOLI,
                           GEP_SOLICITACAO.NRSITUACAO,
                           CASE
                             WHEN SI.NMSITUACAO IS NULL
                             THEN 'Em elaboração'
                             ELSE SI.NMSITUACAO
                           END AS NMSITUACAO,
                           GEP_SOLICITACAO.NRPARCOPERRESP,
                           PA.NMPRINCIPALPARC,
                           PE.NMPERFILACESSO,
                           GEP_SOLICITACAO.CDOPERINCLUSAO,
                           OP.NMOPERADOR,
                           GEP_SOLICITACAO.NRORG,
                           GEP_SOLICITACAO.NRGRUPODEPENDENCIA
                      FROM GEP_SOLICITACAO
                    LEFT JOIN GEP_SITUACAO SI
                                  ON SI.NRORG       = GEP_SOLICITACAO.NRORG
                                  AND SI.NRSITUACAO = GEP_SOLICITACAO.NRSITUACAO
                    LEFT JOIN PERFILACESSO PE
                                  ON PE.NRORG           = GEP_SOLICITACAO.NRORG
                                  AND PE.NRPERFILACESSO = GEP_SOLICITACAO.NRPERFILACESSORESP
                    LEFT JOIN OPERADOR OP
                                  ON OP.NRORG       = GEP_SOLICITACAO.NRORG
                                  AND OP.CDOPERADOR = GEP_SOLICITACAO.CDOPERINCLUSAO
                    LEFT JOIN PARCNEGOCIO PA
                                  ON PA.NRORG          = GEP_SOLICITACAO.NRORG
                                  AND PA.NRPARCNEGOCIO = GEP_SOLICITACAO.NRPARCOPERRESP
                    WHERE GEP_SOLICITACAO.NRORG = $nrorg
                      AND GEP_SOLICITACAO.NRGRUPODEPENDENCIA = $grupo) GEP_SOLICITACAO";

            $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
            return $resultado[0]['TOTAL'];
        } catch(Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }


    /**
     * Set Up.
     *
     * @override DaoGepSolicitacao::setUp()
     *
     * @return void
     */
    public function setUp(){
        parent::setUp();
        $this->hasMany(
            'GepEntregasoli',
            array(
             'local'   => array(
                           0 => 'NRSOLICITACAO',
                           1 => 'NRORG',
                          ),
             'foreign' => array(
                           0 => 'NRSOLICTRLENTREGA',
                           1 => 'NRORG',
                          )
            )
        );

        $this->hasMany(
            'GepAtividade',
            array(
             'local'   => array(
                           0 => 'NRSOLICITACAO',
                           1 => 'NRORG',
                          ),
             'foreign' => array(
                           0 => 'NRSOLICITACAO',
                           1 => 'NRORG',
                          )
            )
        );

    }


    /**
     * * DANIELLE
     * Consulta solicitacoes para uma atividade.
     *
     * @param  integer $nrorg Numero de organizacao.
     *
     * @return string  $query Query da consulta.
     */
    public static function consultaSolicitacaoParaAtividade(){
          $query = "SELECT GEP_SOLICITACAO.NRSOLICITACAO,
                    GEP_SOLICITACAO.DSREFERENCIASOLI,
                    GEP_SOLICITACAO.NRPARCNEGOSOLI ,
                    PARCNEGOSOLI.NMPRINCIPALPARC AS NMPARCNEGOSOLI,
                    GEP_SOLICITACAO.NRPARCOPERSOLI,
                    PARCOPERSOLI.NMPRINCIPALPARC AS NMPARCOPERSOLI,
                    GEP_SOLICITACAO.NRPARCOPERRESP,
                    PARCOPERRESP.NMPRINCIPALPARC AS NMPARCOPERRESP,
                    TP.NRTIPOFLUXO,
                    TP.NMTIPOFLUXO,
                    GEP_SOLICITACAO.NRORG

                    FROM GEP_SOLICITACAO

                    INNER JOIN GEP_TIPOFLUXO TP
                    ON TP.NRTIPOFLUXO = GEP_SOLICITACAO.NRTIPOFLUXO
                    AND TP.NRORG =      GEP_SOLICITACAO.NRORG

                    LEFT JOIN PARCNEGOCIO PARCNEGOSOLI
                    ON PARCNEGOSOLI.NRPARCNEGOCIO = GEP_SOLICITACAO.NRPARCNEGOSOLI
                    AND PARCNEGOSOLI.NRORG        = GEP_SOLICITACAO.NRORG

                    LEFT JOIN PARCNEGOCIO PARCOPERSOLI
                    ON PARCOPERSOLI.NRPARCNEGOCIO = GEP_SOLICITACAO.NRPARCOPERSOLI
                    AND PARCOPERSOLI.NRORG        = GEP_SOLICITACAO.NRORG

                    LEFT JOIN PARCNEGOCIO PARCOPERRESP
                    ON PARCOPERRESP.NRPARCNEGOCIO = GEP_SOLICITACAO.NRPARCOPERRESP
                    AND PARCOPERRESP.NRORG        = GEP_SOLICITACAO.NRORG

                    ORDER BY GEP_SOLICITACAO.NRSOLICITACAO ASC
                    ";
          return $query;
    }

}