var Est95200_AceiteRecusaDivergencias_Controller = function(templateManager, ZhLayoutPreferences, EstUtil, ZhFilterPreferences, Est95200_AceiteRecusaDivergencias_Services) {

    this.onOpenFilter = function(widget) {
        let rowsToSet = {};
        Est95200_AceiteRecusaDivergencias_Services.getFilialLogada().then(success => {
            const { NMFILIAL, CDFILIAL } = success.dataset.filial[0];
            const dtInicial = getLocalVar('DTPROCESSA');
            const dtFinal = moment().endOf('month').format('DD/MM/YYYY');

            rowsToSet.DTCONTAGEM = { "start": dtInicial, "end": dtFinal, "formattedStart": dtInicial, "formattedEnd": dtFinal };
            rowsToSet.NMFILIAL = [NMFILIAL];
            rowsToSet.CDFILIAL = [CDFILIAL];
            rowsToSet.NMRELATORIO = 'EST95200';
            rowsToSet.IDSITUACEITEINV = 'A';
            rowsToSet.ORDENACAO = '1';

            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(() => {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').fields.map(field => {
                    if (field.name === "NMFILIAL" || field.name === "DTCONTAGEM") {
                        field.reload();
                    }
                });
            });
        });
    };

    this.setFilterParams = function(widget, preference = null) {
        let filtro = [];
        const filterRow = preference.FILTER_ROW;

        filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": EstUtil.getFieldValue('CDFILIAL', 'MainWidget', true)
            },
            {
                "name": "DTINICIAL",
                "operator": "=",
                "value": filterRow.DTCONTAGEM ? filterRow.DTCONTAGEM.start : null
            },
            {
                "name": "DTFINAL",
                "operator": "=",
                "value": filterRow.DTCONTAGEM ? filterRow.DTCONTAGEM.end : null
            },
            {
                "name": "ORD",
                "operator": "=",
                "value": EstUtil.getFieldValue('ORD', 'MainWidget', true)
            }
        ];

        let IDSITUACEITEINV = EstUtil.getFieldValue('IDSITUACEITEINV', 'MainWidget', true);
        let situationParam = [];
        switch (IDSITUACEITEINV) {
            case 'A':
                situationParam = [
                    {
                        "name": "SIT",
                        "operator": "=",
                        "value": "A"
                    },
                    {
                        "name": "SIT2",
                        "operator": "=",
                        "value": " "
                    },
                ];
                break;
            case 'R':
                situationParam = [
                    {
                        "name": "SIT",
                        "operator": "=",
                        "value": "R"
                    },
                    {
                        "name": "SIT2",
                        "operator": "=",
                        "value": " "
                    },
                ];
                break;
            case 'T':
                situationParam = [
                    {
                        "name": "SIT",
                        "operator": "=",
                        "value": "A"
                    },
                    {
                        "name": "SIT2",
                        "operator": "=",
                        "value": "R"
                    },
                ];
                break;
            default:
                break;
        }
        filtro.push(situationParam);

        widget.dataSourceFilter = filtro.flat();
        widget.reload();
    };

    this.reportProcess = function(args, afterOpenReport = false) {
        const { owner: widget } = args;

        if (afterOpenReport) {
            ZhLayoutPreferences.applyOriginalLayout(widget);
        }
        else {
            let metadata = args.e.metadata;
            let { start, end } = EstUtil.getFieldValue('DTCONTAGEM', widget.name, true);
            let statusAceite = this.formatReportHeaderData(widget, 'IDSITUACEITEINV');
            let ordenação = this.formatReportHeaderData(widget, 'ORD');

            let filter = [
                {
                    label: "Data de Contagem",
                    value: start + ' a ' + end
                },
                {
                    label: "Situação do Aceite",
                    value: statusAceite
                },
                {
                    label: "Ordenação",
                    value: ordenação
                },
            ];

            metadata.filter = filter;
            metadata.title = 'Aceite/Recusa de Divergências';
            metadata.orientation = 'LANDSCAPE';
            ZhLayoutPreferences.applyOriginalLayout(widget);
        }
    };

    this.formatReportHeaderData = (widget, fieldName) => {
        let value = EstUtil.getFieldValue(fieldName, widget.name, true);

        let newString;
        switch (value) {
            case 'A':
                newString = 'Aprovadas';
                break;
            case 'R':
                newString = 'Recusadas';
                break;
            case 'T':
                newString = 'Ambas';
                break;
            case '1':
                newString = 'Por Unidade - Código';
                break;
            case '2':
                newString = 'Por Unidade - Nome';
                break;
            case '3':
                newString = 'Por Situação do Aceite';
                break;
            case '4':
                newString = 'Por Data/hora do Aceite/Recusa';
                break;
            default:
                break;
        }
        return newString;
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Est95200_AceiteRecusaDivergencias_Controller', Est95200_AceiteRecusaDivergencias_Controller);
});
