var Est95300_ControleFiliaisInventarioCego_Controller = function(templateManager, ZhLayoutPreferences, EstUtil, ZhFilterPreferences, Est95300_ControleFiliaisInventarioCego_Services) {

    this.onOpenFilter = function(widget) {
        let rowsToSet = {};
        Est95300_ControleFiliaisInventarioCego_Services.getFilialLogada().then(success => {
            const { NMFILIAL, CDFILIAL } = success.dataset.filial[0];
            const dtInicial = getLocalVar('DTPROCESSA');
            const dtFinal = moment().endOf('month').format('DD/MM/YYYY');

            rowsToSet.DTCONTAGEM = { "start": dtInicial, "end": dtFinal, "formattedStart": dtInicial, "formattedEnd": dtFinal };
            rowsToSet.NMFILIAL = [NMFILIAL];
            rowsToSet.CDFILIAL = [CDFILIAL];
            rowsToSet.NMRELATORIO = 'EST95300';
            rowsToSet.ORD = '1';

            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(() => {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').fields.map(field => {
                    if (field.name === "NMFILIAL" || field.name === "DTCONTAGEM") {
                        field.reload();
                    }
                });
            });
        });
    };

    this.setFilterParams = function(widget, preference = null) {
        const { FILTER_ROW: filterRow } = preference;
        const UnitiesCode = EstUtil.getFieldValue('CDFILIAL', 'MainWidget', true);

        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "_" + UnitiesCode.join("_") + "_"
            },
            {
                "name": "DTINICIAL",
                "operator": "=",
                "value": filterRow.DTCONTAGEM ? filterRow.DTCONTAGEM.start : null
            },
            {
                "name": "DTFINAL",
                "operator": "=",
                "value": filterRow.DTCONTAGEM ? filterRow.DTCONTAGEM.end : null
            },
            {
                "name": "ORD",
                "operator": "=",
                "value": EstUtil.getFieldValue('ORD', 'MainWidget', true)
            }
        ];

        widget.dataSourceFilter = filter;
        widget.reload();
    };

    this.reportProcess = function(args, afterOpenReport = false) {
        const { owner: widget } = args;

        if (afterOpenReport) {
            ZhLayoutPreferences.applyOriginalLayout(widget);
        }
        else {
            let metadata = args.e.metadata;
            let { start, end } = EstUtil.getFieldValue('DTCONTAGEM', widget.name, true);
            let ordenação = this.formatReportHeaderData(widget, 'ORD');

            let filter = [
                {
                    label: "Ordenação",
                    value: ordenação
                },
                {
                    label: "Data de Contagem",
                    value: start + ' a ' + end
                }
            ];

            metadata.filter = filter;
            ZhLayoutPreferences.applyOriginalLayout(widget);
        }
    };

    this.formatReportHeaderData = (widget, fieldName) => {
        let value = EstUtil.getFieldValue(fieldName, widget.name, true);

        let newString;
        switch (value) {
            case '1':
                newString = 'Por Unidade - Código';
                break;
            case '2':
                newString = 'Por Unidade - Nome';
                break;
            case '3':
                newString = 'Por Qtde Inventários – Crescente';
                break;
            case '4':
                newString = 'Por Qtde Inventários – Decrescente';
                break;
            default:
                break;
        }
        return newString;
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Est95300_ControleFiliaisInventarioCego_Controller', Est95300_ControleFiliaisInventarioCego_Controller);
});
